   This file describes how to use Info, the on-line, menu-driven GNU
documentation system.

   Copyright (C) 1989, 92, 96, 97, 98, 99, 2000, 2001 Free Software
Foundation, Inc.

   Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.1 or
any later version published by the Free Software Foundation; with no
Invariant Sections, with the Front-Cover texts being "A GNU Manual",
and with the Back-Cover Texts as in (a) below.  A copy of the license
is included in the section entitled "GNU Free Documentation License" in
the Emacs manual.

   (a) The FSF's Back-Cover Text is: "You have freedom to copy and
modify this GNU Manual, like GNU software.  Copies published by the Free
Software Foundation raise funds for GNU development."

   This document is part of a collection distributed under the GNU Free
Documentation License.  If you want to distribute this document
separately from the collection, you can do so by adding a copy of the
license to the document, as described in section 6 of the license.

Info: An Introduction
*********************

   Info is a program, which you are using now, for reading
documentation of computer programs.  The GNU Project distributes most
of its on-line manuals in the Info format, so you need a program called
"Info reader" to read the manuals.  One of such programs you are using
now.

   If you are new to Info and want to learn how to use it, type the
command `h' now.  It brings you to a programmed instruction sequence.

   To learn advanced Info commands, type `n' twice.  This brings you to
`Info for Experts', skipping over the `Getting Started' chapter.

Getting Started
***************

   This first part of the Info manual describes how to get around inside
of Info.  The second part of the manual describes various advanced Info
commands, and how to write an Info as distinct from a Texinfo file.
The third part briefly explains how to generate Info files from Texinfo
files.

Starting Info on a Small Screen
===============================

   Since your terminal has a relatively small number of lines on its
screen, it is necessary to give you special advice at the beginning.

   If you see the text `--All----' near the bottom right corner of the
screen, it means the entire text you are looking at fits on the screen.
If you see `--Top----' instead, it means that there is more text below
that does not fit.  To move forward through the text and see another
screen full, press <SPC>, the Space bar.  To move back up, press the
key labeled `Backspace' or `DEL' (on some keyboards, this key might be
labeled `Delete').

   Here are 40 lines of junk, so you can try <SPC> and <DEL> and see
what they do.  At the end are instructions of what you should do next.

This is line 20
This is line 21
This is line 22
This is line 23
This is line 24
This is line 25
This is line 26
This is line 27
This is line 28
This is line 29
This is line 30
This is line 31
This is line 32
This is line 33
This is line 34
This is line 35
This is line 36
This is line 37
This is line 38
This is line 39
This is line 40
This is line 41
This is line 42
This is line 43
This is line 44
This is line 45
This is line 46
This is line 47
This is line 48
This is line 49
This is line 50
This is line 51
This is line 52
This is line 53
This is line 54
This is line 55
This is line 56
This is line 57
This is line 58
This is line 59

   If you have managed to get here, go back to the beginning with `DEL'
(or <BACKSPACE>), and come back here again, then you understand the
about the `Space' and `Backspace' keys.  So now type an `n' --just one
character; don't type the quotes and don't type the Return key
afterward-- to get to the normal start of the course.

How to use Info
===============

   You are talking to the program Info, for reading documentation.

   Right now you are looking at one "Node" of Information.  A node
contains text describing a specific topic at a specific level of
detail.  This node's topic is "how to use Info".  The mode line says
that this is node `Help' in the file `info'.

   The top line of a node is its "header".  This node's header (look at
it now) says that the `Next' node after this one is the node called
`Help-P'.  An advanced Info command lets you go to any node whose name
you know.  In the stand-alone Info reader program, the header line
shows the names of this node and the info file as well.  In Emacs, the
header line is displayed in a special typeface, and it doesn't scroll
off the screen when you scroll the display.  The names of this node and
of its Info file are omitted by Emacs from the header line.

   Besides a `Next', a node can have a `Previous' or an `Up' links, or
both.  As you can see, this node has all of these links.

   Now it is time to move on to the `Next' node, named `Help-P'.

>> Type n to move there.  Type just one character;
   do not type the quotes and do not type a <RET> afterward.

`>>' in the margin means it is really time to try a command.

>> If you have a mouse, and if you already practiced typing n
   to get to the next node, click now with the right mouse button on
   the `Next' link to do the same ``the mouse way''.

Returning to the Previous node
==============================

   This node is called `Help-P'.  The `Previous' node, as you see, is
`Help', which is the one you just came from using the `n' command.
Another `n' command now would take you to the next node, `Help-^L'.  In
Emacs, `n' runs the Emacs command `Info-next', and `p' runs `Info-prev'.

>> But do not type n yet.  First, try the p command,
   or click the mouse on the `Prev' link, which takes you to the
   `Previous' node.  When you get there, you can do an n
   again to return here.

   If you read this in Emacs, you will see an `Info' item in the menu
bar, close to its right edge.  Clicking your mouse on the `Info'
menu-bar item opens a menu of commands which include `Next' and `Prev'
(and also some others which you didn't yet learn about).

   This all probably seems insultingly simple so far, but _do not_ be
led into skimming.  Things will get more complicated soon.  Also, do
not try a new command until you are told it is time to.  Otherwise, you
may make Info skip past an important warning that was coming up.

>> Now do an n, or click the mouse on the `Next' link, to
   get to the node `Help-^L' and learn more.

The Space, DEL, B and ^L commands.
==================================

   This node's mode line tells you that you are now at node `Help-^L',
and the header line tells you that `p' would get you back to `Help-P'.
The node's title is underlined; it says what the node is about (most
nodes have titles).

   This is a big node and it does not all fit on your display screen.
You can tell that there is more that is not visible because you can see
the string `--Top-----' rather than `--All----' near the bottom right
corner of the screen.

   The <SPC>, <BACKSPACE> (or <DEL>)(1) and `b' commands exist to allow
you to "move around" in a node that does not all fit on the screen at
once.  <SPC> moves forward, to show what was below the bottom of the
screen.  <DEL> or <BACKSPACE> moves backward, to show what was above
the top of the screen (there is not anything above the top until you
have typed some spaces).  In Emacs, <SPC> runs the command
`Info-scroll-up', while <BACKSPACE> runs `Info-scroll-down'.

>> Now try typing a <SPC> (afterward, type a <BACKSPACE> to
   return here).

   When you type the <SPC>, the two lines that were at the bottom of
the screen appear at the top, followed by more lines.  <DEL> or
<BACKSPACE> takes the two lines from the top and moves them to the
bottom, _usually_, but if there are not a full screen's worth of lines
above them they may not make it all the way to the bottom.

   If you are reading this in Emacs, note that the header line is
always visible, never scrolling off the display.  That way, you can
always see the `Next', `Prev', and `Up' links, and you can conveniently
go to one of these links from anywhere in the node by clicking the
mouse on one of these links.

   <SPC> and <DEL> not only move forward and backward through the
current node.  When these keys hit the beginning or the end of the
current node, they move to preceding or subsequent nodes.
Specifically, they scroll through all the nodes in an Info file as a
single logical sequence.  In this sequence, a node's subnodes appear
following their parent.  If a node has a menu, <SPC> takes you into the
subnodes listed in the menu, one by one.  Once you reach the end of a
node, and have seen all of its subnodes, <SPC> takes you to the next
node or to the parent's next node.  This is so you could read the
entire manual top to bottom by just typing <SPC>.

   Many keyboards nowadays have two scroll keys labeled `PageUp' and
`PageDown' (or maybe `Prior' and `Next').  If your keyboard has these
keys, you can use them to move forward and backward through the text,
like with <SPC> and <BACKSPACE>.  However, unlike <SPC> and
<BACKSPACE>, <PAGEUP> and <PAGEDOWN> keys will never scroll beyond the
beginning or the end of the current node.

   If your screen is ever garbaged, you can tell Info to display it
again by typing `C-l' (`Control-L', that is--hold down <CTRL> and type
`L' or `l').

>> Type C-l now.

   To move back to the beginning of the node you are on, you can type a
lot of <BACKSPACE> keys.  You can also type simply `b' for beginning.

>> Try that now.  (We have put in enough verbiage to push this past
   the first screenful, but screens are so big nowadays that perhaps it
   isn't enough.  You may need to shrink your Emacs or Info window.)
   Then come back, with <SPS>s.

   If your screen is very tall, all of this node might fit at once.  In
that case, `b' won't do anything.  Sorry; what can we do?

   You have just learned a considerable number of commands.  If you
want to use one but have trouble remembering which, you should type a
`?' (in Emacs it runs the `Info-summary' command) which displays a
brief list of commands.  When you are finished looking at the list,
make it go away by typing a <SPC> repeatedly.

>> Type a <?> now.  Press <SPC> to see consecutive screenfuls of
   the list until finished.  Then type <SPC> several times, until
   it goes away.

   (If you are using the stand-alone Info reader, type `C-x 0' to
return here, that is--press and hold <CTRL>, type an `x', then release
<CTRL> and `x', and press `0'--a zero, not the letter "o".)

   From now on, you will encounter large nodes without warning, and
will be expected to know how to use <SPC> and <BACKSPACE> to move
around in them without being told.  Since not all terminals have the
same size screen, it would be impossible to warn you anyway.

>> Now type n, or click the mouse on the `Next' link, to
   see the description of the m command.

   ---------- Footnotes ----------

   (1) The key which we call "Backspace or DEL" in this manual is
labeled differently on different keyboards.  Look for a key which is a
little ways above the <ENTER> or <RET> key and which you normally use
outside Emacs to erase the character before the cursor, i.e. the
character you typed last.  It might be labeled `Backspace' or `<-' or
`DEL', or sometimes `Delete'.

Menus and the `m' command
=========================

   With only the `n' (next) and `p' (previous) commands for moving
between nodes, nodes are restricted to a linear sequence.  Menus allow
a branching structure.  A menu is a list of other nodes you can move
to.  It is actually just part of the text of the node formatted
specially so that Info can interpret it.  The beginning of a menu is
always identified by a line which starts with `* Menu:'.  A node
contains a menu if and only if it has a line in it which starts that
way.  The only menu you can use at any moment is the one in the node
you are in.  To use a menu in any other node, you must move to that
node first.

   After the start of the menu, each line that starts with a `*'
identifies one subtopic.  The line usually contains a brief name for
the subtopic (followed by a `:'), the name of the node that talks about
that subtopic, and optionally some further description of the subtopic.
Lines in the menu that do not start with a `*' have no special
meaning--they are only for the human reader's benefit and do not define
additional subtopics.  Here is an example:

     * Foo:  Node about FOO      This tells about FOO

   The subtopic name is Foo, and the node describing it is `Node about
FOO'.  The rest of the line is just for the reader's Information.  [[
But this line is not a real menu item, simply because there is no line
above it which starts with `* Menu:'.]]

   When you use a menu to go to another node (in a way that will be
described soon), what you specify is the subtopic name, the first thing
in the menu line.  Info uses it to find the menu line, extracts the
node name from it, and goes to that node.  The reason that there is
both a subtopic name and a node name is that the node name must be
meaningful to the computer and may therefore have to be ugly looking.
The subtopic name can be chosen just to be convenient for the user to
specify.  Often the node name is convenient for the user to specify and
so both it and the subtopic name are the same.  There is an
abbreviation for this:

     * Foo::   This tells about FOO

This means that the subtopic name and node name are the same; they are
both `Foo'.

>> Now use <SPC> to find the menu in this node, then come back to
   the front with a b and some <SPC>s.  As you see, a menu is
   actually visible in its node.  If you cannot find a menu in a node
   by looking at it, then the node does not have a menu and the
   m command is not available.

   The command to go to one of the subnodes is `m'--but _do not do it
yet!_  Before you use `m', you need to learn about commands which
prompt you for more input.  So far, you have learned several commands
that do not need additional input; when you typed one, Info processed
it and was instantly ready for another command.  The `m' command is
different: it is incomplete without the "name of the subtopic".  Once
you have typed `m', Info tries to read the subtopic name.

   Now look for the line containing many dashes near the bottom of the
screen.  There is one more line beneath that one, but usually it is
blank.  If it is empty, Info is ready for a command, such as `n' or `b'
or <SPC> or `m'.  If that line contains text ending in a colon, it
means Info is trying to read more input for the last command.  At such
times, commands do not work, because Info tries to use them as the
input it needs.  You must either type your response and finish the
command you started, or type `Control-g' to cancel the command.  When
you have done one of those things, the line becomes blank again.

   The command to go to a subnode via a menu is `m'.  After you type
the `m', the line at the bottom of the screen says `Menu item: '.  You
must then type the name of the subtopic you want, and end it with a
<RET>.  In Emacs, `m' runs the command `Info-menu'.

   You can abbreviate the subtopic name.  If the abbreviation is not
unique, the first matching subtopic is chosen.  Some menus put the
shortest possible abbreviation for each subtopic name in capital
letters, so you can see how much you need to type.  It does not matter
whether you use upper case or lower case when you type the subtopic.
You should not put any spaces at the end, or inside of the item name,
except for one space where a space appears in the item in the menu.

   You can also use the "completion" feature to help enter the subtopic
name.  If you type the <TAB> key after entering part of a name, it will
magically fill in more of the name--as much as follows uniquely from
what you have entered.

   If you move the cursor to one of the menu subtopic lines, then you do
not need to type the argument: you just type a <RET>, and it stands for
the subtopic of the line you are on.

   Here is a menu to give you a chance to practice.  This menu gives you
three ways of going to one place, Help-FOO:

>>  Now type just an m and see what happens:

   Now you are "inside" an `m' command.  Commands cannot be used now;
the next thing you will type must be the name of a subtopic.

   You can change your mind about doing the `m' by typing `Control-g'.

>> Try that now;  notice the bottom line clear.

>> Then type another m.

>> Now type BAR, the item name.  Do not type <RET> yet.

   While you are typing the item name, you can use the <DEL> (or
<BACKSPACE>) key to cancel one character at a time if you make a
mistake.

>> Press <DEL> to cancel the `R'.  You could type another R
   to replace it.  But you do not have to, since `BA' is a valid
   abbreviation.

>> Now you are ready to go.  Type a <RET>.

   After visiting `Help-FOO', you should return here.

   Another way to move to the menu subtopic lines and between them is
to type <TAB>.  Each time you type a <TAB>, you move to the next
subtopic line.  To move to a previous subtopic line, type
`M-<TAB>'--that is, press and hold the <META> key and then press <TAB>.
(On some keyboards, the <META> key might be labeled `Alt'.)

   Once you move cursor to a subtopic line, press <RET> to go to that
subtopic's node.

   If your terminal supports a mouse, you have yet another way of going
to a subtopic.  Move your mouse pointer to the subtopic line, somewhere
between the beginning `*' and the colon `:' which ends the subtopic's
brief name.  You will see the subtopic's name change its appearance
(usually, its background color will change), and the shape of the mouse
pointer will change if your platform supports that.  After a while, if
you leave the mouse on that spot, a tooltip will pop up saying
"Mouse-2: go to that node".  (If the tooltips are turned off or
unavailable, this message is displayed in the "echo area", the bottom
screen line where you typed the menu subtopics in response to the
prompt.)  `Mouse-2' is the second button of your mouse counting from
the left--the rightmost button for two-button mice, the middle button
for 3-button mice.  So pressing `Mouse-2' while the mouse pointer is on
a menu subtopic goes to that subtopic.

   More generally, `Mouse-2' in an Info buffer runs the Emacs command
`Info-mouse-follow-nearest-node', which finds the nearest link to
another node and goes there.  For example, near a cross reference it
acts like `f', in a menu it acts like `m', on the node's header line it
acts like `n', `p', or `u', etc.  At end of the node's text `Mouse-2'
moves to the next node, or up if there's no next node.

   Here is another way to get to Help-FOO, a menu.  You can ignore this
if you want, or else try it by typing <TAB> and then <RET>, or clicking
`Mouse-2' on it (but then please come back to here).

>> Type n to see more commands.

The `u' command
---------------

   Congratulations!  This is the node `Help-FOO'.  It has an `Up'
pointer `Help-M', the node you just came from via the `m' command.
This is the usual convention--the nodes you reach from a menu have `Up'
nodes that lead back to the menu.  Menus move Down in the tree, and
`Up' moves Up.  `Previous', on the other hand, is usually used to "stay
on the same level but go backwards".

   You can go back to the node `Help-M' by typing the command `u' for
"Up" (the Emacs command run by `u' is `Info-up').  That puts you at the
_front_ of the node--to get back to where you were reading you have to
type some <SPC>s.  (Some Info readers, such as the one built into
Emacs, put you at the same place where you were reading in `Help-M'.)

   Another way to go Up is to click on the `Up' pointer shown in the
header line (provided that you have a mouse).

>> Now type u to move back up to `Help-M'.

Following Cross-References
==========================

   In Info documentation, you will see many "cross references".  Cross
references look like this: Cross.  That text is a
real, live cross reference, whose name is `Cross' and which points to
the node named `Help-Cross'.

   There are two ways to follow a cross reference.  You can move the
cursor to it and press <RET>, just as in a menu.  <RET> follows the
cross reference that the cursor is on.  Or you can type `f' and then
specify the name of the cross reference (in this case, `Cross') as an
argument.  In Emacs Info, `f' runs `Info-follow-reference',

   In the `f' command, you select the cross reference with its name, so
it does not matter where the cursor was.  If the cursor is on or near a
cross reference, `f' suggests that reference name in parentheses as the
default; typing <RET> will follow that reference.  However, if you type
a different reference name, `f' will follow the other reference which
has that name.

>> Type f, followed by Cross, and then <RET>.

   As you enter the reference name, you can use the <DEL> (or
<BACKSPACE>) key to edit your input.  If you change your mind about
following any reference, you can use `Control-g' to cancel the command.
Completion is available in the `f' command; you can complete among all
the cross reference names in the current node by typing a <TAB>.

   To get a list of all the cross references in the current node, you
can type `?' after an `f'.  The `f' continues to await a cross
reference name even after displaying the list, so if you don't actually
want to follow a reference, you should type a `Control-g' to cancel the
`f'.

>> Type f? to get a list of the cross references in this node.  Then
   type a Control-g and see how the `f' gives up.

   The <TAB> and `M-<TAB>' key, which move between menu items in a
menu, also move between cross references outside of menus.

Some intermediate Info commands
===============================

   The introductory course is almost over; please continue a little
longer to learn some intermediate-level commands.

   Most Info files have an index, which is actually a large node that
contains nothing but a menu.  The menu has one menu item for each topic
listed in the index.  You can find the index node from the main menu of
the file, with the `m' command; then you can use the `m' command again
in the index node to go to the node that describes the topic.

   There is also a short-cut Info command, `i', which does all of that
for you.  It searches the index for a given topic (a string) and goes
to the node which is listed in the index for that topic.  See Info Search,
for a full explanation.

   If you have been moving around to different nodes and wish to
retrace your steps, the `l' command (`l' for "last") will do that, one
node-step at a time.  As you move from node to node, Info records the
nodes where you have been in a special history list.  The `l' command
revisits nodes in the history list; each successive `l' command moves
one step back through the history.

   If you have been following directions, ad `l' command now will get
you back to `Help-M'.  Another `l' command would undo the `u' and get
you back to `Help-FOO'.  Another `l' would undo the `m' and get you
back to `Help-M'.

   In Emacs, `l' runs the command `Info-last'.

>> Try typing three l's, pausing in between to see what each
   l does.  Then follow directions again and you will end up
   back here.

   Note the difference between `l' and `p': `l' moves to where _you_
last were, whereas `p' always moves to the node which the header says
is the `Previous' node (from this node, the `Prev' link leads to
`Help-M').

   The `d' command (`Info-directory' in Emacs) gets you instantly to
the Directory node.  This node, which is the first one you saw when you
entered Info, has a menu which leads (directly or indirectly, through
other menus), to all the nodes that exist.  The Directory node lists
all the manuals and other Info documents that are, or could be,
installed on your system.

>> Try doing a d, then do an l to return here (yes,
   _do_ return).

   The `t' command moves to the `Top' node of the manual.  This is
useful if you want to browse the manual's main menu, or select some
specific top-level menu item.  The Emacs command run by `t' is
`Info-top-node'.

   Clicking `Mouse-2' on or near a cross reference also follows the
reference.  You can see that the cross reference is mouse-sensitive by
moving the mouse pointer to the reference and watching how the
underlying text and the mouse pointer change in response.

>> Now type n to see the last node of the course.

   See Advanced Info, for more advanced Info features.

Info for Experts
****************

   This chapter describes various advanced Info commands.  (If you are
using a stand-alone Info reader, there are additional commands specific
to it, which are documented in several chapters of GNU Info (info-stnd).)

   This chapter also explains how to write an Info as distinct from a
Texinfo file.  (However, in most cases, writing a Texinfo file is
better, since you can use it _both_ to generate an Info file and to
make a printed manual.  See Overview of Texinfo (texinfo).)

Advanced Info Commands
======================

   Here are some more Info commands that make it easier to move around.

`g' goes to a node by name
--------------------------

   If you know a node's name, you can go there by typing `g', the name,
and <RET>.  Thus, `gTop<RET>' would go to the node called `Top' in this
file.  (This is equivalent to `t', see Help-Int.)
`gExpert<RET>' would come back here.  `g' in Emacs runs the command
`Info-goto-node'.

   Unlike `m', `g' does not allow the use of abbreviations.  But it
does allow completion, so you can type <TAB> to complete a partial node
name.

   To go to a node in another file, you can include the file name in the
node name by putting it at the front, in parentheses.  Thus,
`g(dir)Top<RET>' would go to the Info Directory node, which is the node
`Top' in the Info file `dir'.  Likewise, `g(emacs)Top<RET>' goes to the
top node of the Emacs manual.

   The node name `*' specifies the whole file.  So you can look at all
of the current file by typing `g*<RET>' or all of any other file with
`g(FILENAME)<RET>'.

`1' - `9' choose a menu subtopic by its number
----------------------------------------------

   If you begrudge each character of type-in which your system requires,
you might like to use the commands `1', `2', `3', `4', ..., `9'.  They
are short for the `m' command together with a name of a menu subtopic.
`1' goes through the first item in the current node's menu; `2' goes
through the second item, etc.  In the stand-alone reader, `0' goes
through the last menu item; this is so you need not count how many
entries are there.  In Emacs, the digit keys run the command
`Info-nth-menu-item'.

   If your display supports multiple fonts, and you are using Emacs'
Info mode to read Info files, the `*' for the fifth menu item stands
out, either in color or in some other attribute, such as underline, and
so is the `*' for the ninth item; this makes it easy to see at a glance
which number to use for an item.

   Some terminals don't support colors or underlining.  If you need to
actually count items, it is better to use `m' instead, and specify the
name, or use <TAB> to quickly move between menu items.

`e' makes Info document editable
--------------------------------

   The Info command `e' changes from Info mode to an ordinary Emacs
editing mode, so that you can edit the text of the current node.  Type
`C-c C-c' to switch back to Info.  The `e' command is allowed only if
the variable `Info-enable-edit' is non-`nil'.

   The `e' command only works in Emacs, where it runs the command
`Info-edit'.  The stand-alone Info reader doesn't allow you to edit the
Info file, so typing `e' there goes to the end of the current node.

How to search Info documents for specific subjects
==================================================

   The commands which move between and inside nodes allow you to read
the entire manual or its large portions.  But what if you need to find
some information in the manual as fast as you can, and you don't know
or don't remember in what node to look for it?  This need arises when
you use a manual as a "reference", or when it is impractical to read
the entire manual before you start using the programs it describes.

   Info has powerful searching facilities that let you find things
quickly.  You can search either the manual indices or its text.

   Since most subjects related to what the manual describes should be
indexed, you should try the index search first.  The `i' command
prompts you for a subject and then looks up that subject in the
indices.  If it finds an index entry with the subject you typed, it
goes to the node to which that index entry points.  You should browse
through that node to see whether the issue you are looking for is
described there.  If it isn't, type `,' one or more times to go through
additional index entries which match your subject.

   The `i' command finds all index entries which include the string you
typed _as a substring_.  For each match, Info shows in the echo area
the full index entry it found.  Often, the text of the full index entry
already gives you enough information to decide whether it is relevant
to what you are looking for, so we recommend that you read what Emacs
shows in the echo are before looking at the node it displays.

   Since `i' looks for a substring, you can search for subjects even if
you are not sure how they are spelled in the index.  For example,
suppose you want to find something that is pertinent to commands which
complete partial input (e.g., when you type <TAB>).  If you want to
catch index entries that refer to "complete", "completion", and
"completing", you could type `icomplet<RET>'.

   Info documents which describe programs should index the commands,
options, and key sequences that the program provides.  If you are
looking for a description of a command, an option, or a key, just type
their names when `i' prompts you for a topic.  For example, if you want
to read the description of what the `C-f' key does, type `iC-f<RET>'.
Here `C-f' are 3 literal characters `C', `-', and `f', not the
"Control-f" command key you type inside Emacs to run the command bound
to `C-f'.

   In Emacs, `i' runs the command `Info-index'.

   The `s' command allows you to search a whole file for a string.  It
switches to the next node if and when that is necessary.  You type `s'
followed by the string to search for, terminated by <RET>.  To search
for the same string again, just `s' followed by <RET> will do.  The
file's nodes are scanned in the order they are in in the file, which
has no necessary relationship to the order that they may be in the tree
structure of menus and `next' pointers.  But normally the two orders
are not very different.  In any case, you can always do a `b' to find
out what node you have reached, if the header is not visible (this can
happen, because `s' puts your cursor at the occurrence of the string,
not at the beginning of the node).

   In Emacs, `Meta-s' is equivalent to `s'.  That is for compatibility
with other GNU packages that use `M-s' for a similar kind of search
command.  Both `s' and `M-s' run in Emacs the command `Info-search'.

Adding a new node to Info
=========================

   To add a new topic to the list in the Info directory, you must:

  1. Create some nodes, in some file, to document that topic.

  2. Put that topic in the menu in the directory.  See Menu.

   Usually, the way to create the nodes is with Texinfo (see Overview of Texinfo (texinfo));
this has the advantage that you can also
make a printed manual from them.  However, if you want to edit an Info
file, here is how.

   The new node can live in an existing documentation file, or in a new
one.  It must have a `^_' character before it (invisible to the user;
this node has one but you cannot see it), and it ends with either a
`^_', a `^L' ("formfeed"), or the end of file.(1)

   The `^_' starting a node must be followed by a newline or a `^L'
newline, after which comes the node's header line.  The header line
must give the node's name (by which Info finds it), and state the names
of the `Next', `Previous', and `Up' nodes (if there are any).  As you
can see, this node's `Up' node is the node `Top', which points at all
the documentation for Info.  The `Next' node is `Menus'.

   The keywords "Node", "Next", "Previous", and "Up" may appear in any
order, anywhere in the header line, but the recommended order is the
one in this sentence.  Each keyword must be followed by a colon, spaces
and tabs, and then the appropriate name.  The name may be terminated
with a tab, a comma, or a newline.  A space does not end it; node names
may contain spaces.  The case of letters in the names is insignificant.

   A node name has two forms.  A node in the current file is named by
what appears after the `Node: ' in that node's first line.  For
example, this node's name is `Add'.  A node in another file is named by
`(FILENAME)NODE-WITHIN-FILE', as in `(info)Add' for this node.  If the
file name starts with "./", then it is relative to the current
directory; otherwise, it is relative starting from the standard
directory for Info files of your site.  The name `(FILENAME)Top' can be
abbreviated to just `(FILENAME)'.  By convention, the name `Top' is used
for the "highest" node in any single file--the node whose `Up' points
out of the file.  The `Directory' node is `(dir)', it points to a file
`dir' which holds a large menu listing all the Info documents installed
on your site.  The `Top' node of a document file listed in the
`Directory' should have an `Up: (dir)' in it.

   The node name `*' is special: it refers to the entire file.  Thus,
`g*' shows you the whole current file.  The use of the node `*' is to
make it possible to make old-fashioned, unstructured files into nodes
of the tree.

   The `Node:' name, in which a node states its own name, must not
contain a file name, since when Info searches for a node, it does not
expect a file name to be there.  The `Next', `Previous' and `Up' names
may contain them.  In this node, since the `Up' node is in the same
file, it was not necessary to use one.

   Note that the nodes in this file have a file name in the header
line.  The file names are ignored by Info, but they serve as comments
to help identify the node for the user.

   ---------- Footnotes ----------

   (1) If you put in a `^L' to end a new node, be sure that there is a
`^_' after it to start the next one, since `^L' cannot _start_ a node.
Also, a nicer way to make a node boundary be a page boundary as well is
to put a `^L' _right after_ the `^_'.

How to Create Menus
===================

   Any node in the Info hierarchy may have a "menu"--a list of subnodes.
The `m' command searches the current node's menu for the topic which it
reads from the terminal.

   A menu begins with a line starting with `* Menu:'.  The rest of the
line is a comment.  After the starting line, every line that begins
with a `* ' lists a single topic.  The name of the topic-what the user
must type at the `m''s command prompt to select this topic--comes right
after the star and space, and is followed by a colon, spaces and tabs,
and the name of the node which discusses that topic.  The node name,
like node names following `Next', `Previous' and `Up', may be
terminated with a tab, comma, or newline; it may also be terminated
with a period.

   If the node name and topic name are the same, then rather than
giving the name twice, the abbreviation `* NAME::' may be used (and
should be used, whenever possible, as it reduces the visual clutter in
the menu).

   It is considerate to choose the topic names so that they differ from
each other very near the beginning--this allows the user to type short
abbreviations.  In a long menu, it is a good idea to capitalize the
beginning of each item name which is the minimum acceptable
abbreviation for it (a long menu is more than 5 or so entries).

   The nodes listed in a node's menu are called its "subnodes", and it
is their "superior".  They should each have an `Up:' pointing at the
superior.  It is often useful to arrange all or most of the subnodes in
a sequence of `Next' and `Previous' pointers so that someone who wants
to see them all need not keep revisiting the Menu.

   The Info Directory is simply the menu of the node `(dir)Top'--that
is, node `Top' in file `.../info/dir'.  You can put new entries in that
menu just like any other menu.  The Info Directory is _not_ the same as
the file directory called `info'.  It happens that many of Info's files
live in that file directory, but they do not have to; and files in that
directory are not automatically listed in the Info Directory node.

   Also, although the Info node graph is claimed to be a "hierarchy",
in fact it can be _any_ directed graph.  Shared structures and pointer
cycles are perfectly possible, and can be used if they are appropriate
to the meaning to be expressed.  There is no need for all the nodes in
a file to form a connected structure.  In fact, this file has two
connected components.  You are in one of them, which is under the node
`Top'; the other contains the node `Help' which the `h' command goes
to.  In fact, since there is no garbage collector, nothing terrible
happens if a substructure is not pointed to, but such a substructure is
rather useless since nobody can ever find out that it exists.

Creating Cross References
=========================

   A cross reference can be placed anywhere in the text, unlike a menu
item which must go at the front of a line.  A cross reference looks
like a menu item except that it has `*note' instead of `*'.  It
_cannot_ be terminated by a `)', because `)''s are so often part of
node names.  If you wish to enclose a cross reference in parentheses,
terminate it with a period first.  Here are two examples of cross
references pointers:

     details.  (See 3)

_These are just examples._  The places they "lead to" do not really
exist!

The node reached by the cross reference in Info
-----------------------------------------------

   This is the node reached by the cross reference named `Cross'.

   While this node is specifically intended to be reached by a cross
reference, most cross references lead to nodes that "belong" someplace
else far away in the structure of an Info document.  So you cannot
expect this node to have a `Next', `Previous' or `Up' links pointing
back to where you came from.  In general, the `l' (el) command is the
only way to get back there.

>> Type l to return to the node where the cross reference was.

Quitting Info
=============

   To get out of Info, back to what you were doing before, type `q' for
"Quit".  This runs `Info-exit' in Emacs.

   This is the end of the basic course on using Info.  You have learned
how to move in an Info document, and how to follow menus and cross
references.  This makes you ready for reading manuals top to bottom, as
new users should do when they learn a new package.

   Another set of Info commands is useful when you need to find
something quickly in a manual--that is, when you need to use a manual
as a reference rather than as a tutorial.  We urge you to make learn
these search commands as well.  If you want to do that now, follow this
cross reference to Info Search.

   Yet another set of commands are meant for experienced users; you can
find them by looking in the Directory node for documentation on Info.
Finding them will be a good exercise in using Info in the usual manner.

>> Type d to go to the Info directory node; then type
   mInfo and Return, to get to the node about Info and
   see what other help is available.

Tags Tables for Info Files
==========================

   You can speed up the access to nodes of a large Info file by giving
it a tags table.  Unlike the tags table for a program, the tags table
for an Info file lives inside the file itself and is used automatically
whenever Info reads in the file.

   To make a tags table, go to a node in the file using Emacs Info mode
and type `M-x Info-tagify'.  Then you must use `C-x C-s' to save the
file.  Info files produced by the `makeinfo' command that is part of
the Texinfo package always have tags tables to begin with.

   Once the Info file has a tags table, you must make certain it is up
to date.  If you edit an Info file directly (as opposed to editing its
Texinfo source), and, as a result of deletion of text, any node moves
back more than a thousand characters in the file from the position
recorded in the tags table, Info will no longer be able to find that
node.  To update the tags table, use the `Info-tagify' command again.

   An Info file tags table appears at the end of the file and looks like
this:

     ^_^L
     Tag Table:
     File: info, Node: Cross-refs^?21419
     File: info,  Node: Tags^?22145
     ^_
     End Tag Table

Note that it contains one line per node, and this line contains the
beginning of the node's header (ending just after the node name), a
`DEL' character, and the character position in the file of the
beginning of the node.

Checking an Info File
=====================

   When creating an Info file, it is easy to forget the name of a node
when you are making a pointer to it from another node.  If you put in
the wrong name for a node, this is not detected until someone tries to
go through the pointer using Info.  Verification of the Info file is an
automatic process which checks all pointers to nodes and reports any
pointers which are invalid.  Every `Next', `Previous', and `Up' is
checked, as is every menu item and every cross reference.  In addition,
any `Next' which does not have a `Previous' pointing back is reported.
Only pointers within the file are checked, because checking pointers to
other files would be terribly slow.  But those are usually few.

   To check an Info file, do `M-x Info-validate' while looking at any
node of the file with Emacs Info mode.

Emacs Info-mode Variables
=========================

   The following variables may modify the behavior of Info-mode in
Emacs; you may wish to set one or several of these variables
interactively, or in your `~/.emacs' init file.  See Examining and Setting Variables (emacs).
The stand-alone Info reader
program has its own set of variables, described in Manipulating Variables (info-stnd).

`Info-directory-list'
     The list of directories to search for Info files.  Each element is
     a string (directory name) or `nil' (try default directory).  If not
     initialized Info uses the environment variable `INFOPATH' to
     initialize it, or `Info-default-directory-list' if there is no
     `INFOPATH' variable in the environment.

     If you wish to customize the Info directory search list for both
     Emacs info and stand-alone Info, it is best to set the `INFOPATH'
     environment variable, since that applies to both programs.

`Info-additional-directory-list'
     A list of additional directories to search for Info documentation
     files.  These directories are not searched for merging the `dir'
     file.

`Info-fontify'
     When set to a non-`nil' value, enables highlighting of Info files.
     The default is `t'.  You can change how the highlighting looks by
     customizing the faces `info-node', `info-menu-5', `info-xref',
     `info-header-xref', `info-header-node', `info-title-N-face' (where
     N is the level of the section, a number between 1 and 4), and
     `info-menu-header'.  To customize a face, type `M-x customize-face
     <RET> FACE <RET>', where FACE is one of the face names listed here.

`Info-use-header-line'
     If non-`nil', Emacs puts in the Info buffer a header line showing
     the `Next', `Prev', and `Up' links.  A header line does not scroll
     with the rest of the buffer, making these links always visible.

`Info-scroll-prefer-subnodes'
     If set to a non-`nil' value, <SPC> and <BACKSPACE> (or <DEL>) keys
     in a menu visit subnodes of the current node before scrolling to
     its end or beginning, respectively.  For example, if the node's
     menu appears on the screen, the next <SPC> moves to a subnode
     indicated by the following menu item.  Setting this option to
     `nil' results in behavior similar to the stand-alone Info reader
     program, which visits the first subnode from the menu only when you
     hit the end of the current node.  The default is `t'.

`Info-enable-active-nodes'
     When set to a non-`nil' value, allows Info to execute Lisp code
     associated with nodes.  The Lisp code is executed when the node is
     selected.  The Lisp code to be executed should follow the node
     delimiter (the `DEL' character) and an `execute: ' tag, like this:

          ^_execute: (message "This is an active node!")

`Info-enable-edit'
     Set to `nil', disables the `e' (`Info-edit') command.  A non-`nil'
     value enables it.  See Edit.

Creating an Info File from a Texinfo File
*****************************************

   `makeinfo' is a utility that converts a Texinfo file into an Info
file; `texinfo-format-region' and `texinfo-format-buffer' are GNU Emacs
functions that do the same.

   See Overview of Texinfo (texinfo), to learn how to write a
Texinfo file.

   See Creating an Info File (texinfo), to
learn how to create an Info file from a Texinfo file.

   See Installing an Info File (texinfo), to
learn how to install an Info file after you have created one.

Index
*****

   This is an alphabetical listing of all the commands, variables, and
topics discussed in this document.